﻿//
//   Copyright 2016 North Atlantic Publishing Systems, Inc.
//   All Rights Reserved
//     www.napsys.com
//

//#targetengine "session"

// 6.6.16 - remove add & remove delete checks for speed.
//              move render into idle - try immediate place - rather than push 
//      
//             ? look at open to see if we have a modal open
//             

var ix={};   // our namespace object
ix.xLib = null;
var IX_LISTENER_NAME = "Integration-X Client";
var idlesRelink=[];
var idlesImport=[];
var idlesReplaces=[];
var idlesReturnOpenedPageList=[];
var idlesReturnOpenedAdList=[];
var idlesDocs=[];
var delim = '£';

var tryAlt=false;

var doDeleteCheck = false;

//-----------------------------------------------------------------------------       
//var ix_idleTask=null


if (typeof String.prototype.endsWith !== 'function') {
    String.prototype.endsWith = function(suffix) {
        return this.indexOf(suffix, this.length - suffix.length) !== -1;
    };
}

Date.prototype.format = function (format) {
      var o = {
        "M+" : this.getMonth()+1, //month
        "d+" : this.getDate(),    //day
        "h+" : this.getHours(),   //hour
        "m+" : this.getMinutes(), //minute
        "s+" : this.getSeconds(), //second
        "q+" : Math.floor((this.getMonth()+3)/3),  //quarter
        "S" : this.getMilliseconds() //millisecond
      }

    if(/(y+)/.test(format)) format=format.replace(RegExp.$1,(this.getFullYear()+"").substr(4 - RegExp.$1.length));
    for(var k in o)if(new RegExp("("+ k +")").test(format))
    format = format.replace(RegExp.$1,
    RegExp.$1.length==1 ? o[k] :
    ("00"+ o[k]).substr((""+ o[k]).length));
    return format;
}

Array.prototype.find = function (what) {
    var rtn=false;
    for (var n=0;n<this.length;n++) {
        if (what==this[n]) return true;
    }
    return rtn;
}

//-----------------------------------------------------------------------------       



var haveListener=false;

ix.init=function (extensionSysPath) {
  
     if (ix.inited==true) {
           ix.wr("Already inited");
           return ( ix.manifestVersion );
     }
 
    ix.wrLog(" ix.init()  listeners ="+app.eventListeners.length);
    
    for (var u = 0; u<app.eventListeners.length; u++) {
        var thisListener = app.eventListeners[u];
        if (thisListener!=null && thisListener.isValid) {
            ix.wr (thisListener.eventType+"  listener name = "+thisListener.name+"    handler name = "+ thisListener.handler.name);
        }
        if (thisListener.name==IX_LISTENER_NAME) haveListener=true;
    }

    if (haveListener==false) {
            ix.openListener = app.addEventListener ("afterOpen", ix.afterOpenListener, false);    
            ix.openListener.name = IX_LISTENER_NAME;
            ix.wr("Add Open listener");
    }
   
   try {
        with (app.linkingPreferences){
            checkLinksAtOpen = false;
            findMissingLinksAtOpen = true;
         }
   } catch (e) {
      ix.wr (" app.linkingPreferences "+e);
   }

    ixLoadMenus();

    ix.idleTask = null;
    idlesRelink = [];
    idlesImport = [];
    idlesReturnOpenedPageList=[];
    idlesReturnOpenedAdList=[];
    idlesDocs = [];
    //ix.idleDoc = null;
    ix.addIdleTask();

   // ix.quitListener  = app.addEventListener ("IXafterQuit", IXafterQuit, false);   // indesign quits
   
    ix.displayEventListener = app.addEventListener("beforeDisplay", beforeDisplayHandler, false); 

       try {
            ix.xLib = new ExternalObject("lib:\PlugPlugExternalObject");
        } catch (e) {
            ix.wr (" ix:ExternalObject: "+e);
      }
  
    ix.inited = true;
    
    ix.wr(app.name);
    ix.wr(app.version);
    ix.wr(ix.getPlatform());
    ix.wr(Folder.fs.toString());
    ix.wr("Engine : "+$.engineName.toString());
    ix.wr("Locale "+$.locale);
    ix.wr(extensionSysPath);

    if (extensionSysPath!="") {
        ix.manifestVersion = ix.getExtensionVersionFromManifest(extensionSysPath);
    }

  //app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;
  
   // render the one we opened with
    var myDoc = ix.getFrontDoc();
    if (myDoc != null) {
        ix.eventsRenderADocLater(myDoc);
    }
    
    /*
    if ( myDoc != null) {    
        var docType = ix.tryToRenderDocument (myDoc) ;
        if (docType != "") {
               ix.setLabel (myDoc, "docType", docType);
        }       
    } else {
        ix.wr("No doc open at init");
        tryAlt=true;
    }
    */ 

 //app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

    ix.applicationName = (app.name+" "+app.version).replace("Adobe ","");
    return ( ix.manifestVersion+"$"+ix.applicationName+"$"+$.locale.toString().replace("_","-") );
}

function beforeDisplayHandler (evt) {
    ix.wr("beforeDisplayHandler "+evt.target);
}


ix.deinit = function () {
    //alert("quitter");
      ix.wrLog(" Integration-X client quits ");
}

ix.getFrontDoc = function () {
    var myDoc = null;
    try {
       myDoc = app.activeDocument ;
    } catch (e) {
       ix.wr ("ix.getFrontDoc "+e);
       myDoc = null;
    }
    return myDoc;
}

/*
ix.openAndRenderFrontmost = function () {
     var myDoc = ix.getFrontDoc();
    if ( myDoc != null) {    
        var docType = ix.tryToRenderDocument (myDoc) ;
        if (docType != "") {
               ix.setLabel (myDoc, "docType", docType);
        }       
    }
}
*/

ix.getFrontDocType = function () {
    var myDoc = null;
    try {
       myDoc = app.activeDocument ;
       var docType = ix.getLabel (myDoc, "docType");
    } catch (e) {
       ix.wr("ix.getFrontDocType "+e);
    }
    return docType;
}

//function IXafterQuit (evt) {
//     ix.wrLog(" InDesign Quits ");
//}

ix.afterOpenListener = function (evt) {
    
   ix.wr("ix.afterOpenListener evt.target "+evt.target);
   
   if (evt instanceof DocumentEvent == false ){
        ix.wr ("    ix.afterOpenListener not a document event "+evt);
       return;   
   }

   var myDoc =  evt.target;
   if (myDoc != null) {
        ix.eventsRenderADocLater(myDoc);
    }
   /*
   var docType = ix.tryToRenderDocument (myDoc) ;
   if (docType !="") {
       ix.setLabel (myDoc, "docType", docType);
   }
   */
 
}

ix.tryToRenderDocument = function (myDoc) {
   var rtn = "";
   var myDocsFileObj = null;
   
   ix.wr("tryToRenderDocument start "+myDoc.name);
 
   var isPlanPointDoc = false;
   var isAdPointDoc   = false;
   
    if (myDoc instanceof Document) {
           try {
                myDocsFileObj = new File(myDoc.fullName);
           } catch(e) {
               ix.wrLog(" tryToRenderDocument - try to save un-saved doc ");
               myDocsFileObj=null;
               myDoc.save();
           }
        
           if (myDocsFileObj== null) {
               try {
                myDocsFileObj = new File(myDoc.fullName);
               } catch (e) {
                   ix.tell_JS ("rerender$ $ "); // send 3 args
                   return rtn;
               }
           }
       
       
           var myDocsFolderPath = ix.ensurePathEndsInSlash(myDocsFileObj.parent.fsName);
                     
           var myXmlDocName = myDoc.name;                //.replace(".indd","");
                                                                                // myXmlDocName = myXmlDocName.replace(".INDD","");
           myXmlDocName = myXmlDocName+".xml";
                
           var myXmlFileObj = new File (myDocsFolderPath+myXmlDocName) ;
           if (myXmlFileObj.exists==true) {
                ix.wrLog("Opened "+myDoc.name);
                var xmlData = ix.readFileIntoXML (myDocsFolderPath+myXmlDocName,"PlanPoint XML file")
                 if (xmlData==null) {
                       ix.wrLog("XML parse failed "+myDocsFolderPath+myXmlDocName);
                     return "";
                 }
             
                 ix.wrLog("Read "+myDocsFolderPath+myXmlDocName);
                 ix.setCoordSchemeToPage (myDoc,0);
                 
                 try {
                     var tmpstr = xmlData.@parent.toString();
                     if (tmpstr=="") isPlanPointDoc = true;
                     //if (tmpstr.indexOf(".Page.")>0 ) isPlanPointDoc = true;
                     else if (tmpstr.indexOf(".MaterialSpecification.")>0 ) isAdPointDoc = true;
                     
                 } catch (e) {
                     ix.wr("tryToRenderDocument exception "+ e);
                 }
                 
                 if (isPlanPointDoc) {
                      ix.tell_JS ("open$" + myDocsFolderPath+"$PlanPoint");      // this triggers comm open above  
                      ix.renderDoc (myDoc,xmlData,0,myDocsFolderPath);
                      rtn = "PlanPoint";
                     // if (tryAlt==true) {
                     //     ix.handleTheIdle();  // rather than wait for idel to do....
                     // }
                 }
                 if (isAdPointDoc)  {
                      ix.tell_JS ("open$" + myDocsFolderPath+"$AdPoint");      // this triggers comm open above  
                      ix.renderAd   (myDoc,xmlData,0,myDocsFolderPath);
                     
                      rtn = "AdPoint";
                 }
                 ix.restoreCoordScheme(myDoc);
                
                 
           } else {
                ix.wrLog("Not an IX doc. "+myDoc.name);
                ix.wr("Not an IX doc. myDocsFolderPath+myXmlDocName missing "+myDocsFolderPath+myXmlDocName);  
               return "";   // ignore file if no matching xml doc for it
           }
     } else {
            ix.wr("ix.afterOpenListener error target is not a Document "+evt.target);
     }
    return rtn;
}

ix.renderDoc = function (myDoc, xmlData, ignoredVal, rootFolder) {

   var pageIndex=0
   var pageObj = null;
   var pageListDataForPlanPoint="";     
   


   //ix.noneColorSwatch =  myDoc.swatches.itemByName("[None]"); //("None");'$ID/[None]'
   
   //ix.wr ("ix none swatch "+ix.noneColorSwatch);

    ix.backgroundColorSwatch = ix.colorAdd (myDoc, "IX Light Gray", ColorModel.PROCESS, ColorSpace.RGB, [200, 200, 200]);
 
    xmlData.@application = ix.applicationName; // read from environment

    // get resource attribute list & save list of att names in string array - store in "IX_ELEMENT_ATTRIBUTE_LIST"
    //  then store each att on doc with label = attribute name - so we can reconstruct the xml
    
    ix.saveTheXMLAttributes(myDoc,xmlData);
    
     
    //var aList = xmlData.attributes();
    
    var pageList = xmlData.descendants('page');
    
    if (pageList.length() != myDoc.pages.length) {
        if ( (pageList.length()-myDoc.pages.length) == 1) {
            try {
                myDoc.pages.add (LocationOptions.AFTER, myDoc.pages.item(0) );
            } catch (e) {
                 ix.wr(" doc render exception on add page "+e);
            }
        } else {
            ix.doAlert("PlanPoint expects "+pageList.length()+" pages, but there are "+myDoc.pages.length+" in this document. Please correct.");
        }
    }
    
    for (pageIndex=0; pageIndex<pageList.length(); pageIndex++) {
        
         pageObj =  myDoc.pages.item(pageIndex);
         if (pageObj instanceof Page == false || pageObj.isValid==false ) {
             ix.wr ("ix.renderDoc invalid Page ref " +pageIndex);
             continue;
         }
       
               // set this page number other meta data 

       if (pageIndex==0) {
            // set page number from xml into doc
            var pgNum = parseInt(pageList[pageIndex].@page_number.toString(),10);
            if (pgNum>0 && pgNum <999999) {
                myDoc.documentPreferences.startPageNumber = pgNum;
            }
            var seedDate = pageList[pageIndex].@publication_date.toString();
             ix.tell_JS ("getDateInfo$"+seedDate);   
      } else {
          // ?? to do to all pages other than first
      }
   
       //    ix.searchAndReplaceOnThisPage 
       //    replace tags with meta data  - search this page only 
        ix.searchAndReplaceOnThisPage ( myDoc,"[Issuedate]", pageList[pageIndex].@publication_date.toString(), pageObj );
        ix.searchAndReplaceOnThisPage ( myDoc,"[Editorialdepartment]", pageList[pageIndex].@editorialdepartment.toString(), pageObj );
        ix.searchAndReplaceOnThisPage ( myDoc,"[Product]", pageList[pageIndex].@product.toString(), pageObj );
        ix.searchAndReplaceOnThisPage ( myDoc,"[Zone]", pageList[pageIndex].@zone.toString(), pageObj );
         //       ix.searchAndReplace ( "[Zone]", pageList[pageIndex].@zone.toString() );

        ix.searchAndReplaceOnThisPage ( myDoc,"[Section]", pageList[pageIndex].@section.toString(), pageObj );
        ix.searchAndReplaceOnThisPage ( myDoc,"[Department]", pageList[pageIndex].@department.toString(), pageObj );
        
        idlesReplaces.push(pageObj);

        if (pageListDataForPlanPoint =="") {
            pageListDataForPlanPoint = pageList[pageIndex].@parent.toString() ;
        } else {
            pageListDataForPlanPoint += delim + pageList[pageIndex].@parent.toString() 
        }
  
       // save the page element attribs on the pageObj
   
       ix.wr ("ix.renderDoc  Page ref " +pageObj);
       ix.saveTheXMLAttributes(pageObj, pageList[pageIndex]); 
    
        var imList = pageList[pageIndex].descendants('image');   // get list of image frame to make
    
        // then create image frames and import images
        var theFrame = null;
        for (var i=0;i<imList.length();i++) {
            var topLeft = {};
            theFrame=null;
            
            topLeft.x  = imList[i].@x.toString();
            topLeft.y  = imList[i].@y.toString();
            var width  = imList[i].@width.toString();
            var height = imList[i].@height.toString();
            
            var bean = imList[i].@bean.toString();
            
            theFrame = ix.findFrameByBeanAndPage (myDoc, pageObj, bean);  //??  was myDoc
            
            if (theFrame == null ) {
                theFrame = ix.createFrame (pageObj, topLeft, width, height);
                ix.wr( " Create frame with id of "+theFrame.id+" for "+bean);
            } else {
                theFrame = ix.resetFrame (theFrame, topLeft, width, height);
                ix.wr( " Reset frame for "+bean);
            }
        
            ix.saveTheXMLAttributes(theFrame,imList[i]);  // save the image level attribs on image frame
            
            if (theFrame==null) continue;
            theFrame.locked=false;
           
            ix.flushTextFrame(theFrame);   
            theFrame.fillColor  = "None";  
            
            var imagePath = imList[i].@path;
            if ( imagePath !=""  && imagePath != undefined ) {
                 // ix.placeImage (myDoc, theFrame, rootFolder+imagePath);                             // 6-10
                  // now use idle below  to import    //ix.postImportImage  (theFrame.id, forwardSlasher(rootFolder+imagePath) );
                  //idlesImport.push( {frameId:theFrame.id, linkPath:forwardSlasher(rootFolder+imagePath), docId:myDoc.id} );   // 6-10
                  //ix.wr(' save for idle import ' +theFrame.id +' '+ forwardSlasher(rootFolder+imagePath)+' '+myDoc.id);
  
               // rework - 6/25/16
               var thereIsAnImageInPlace=false;
               try {
                    if (theFrame.graphics.length >0) thereIsAnImageInPlace=true;
               } catch (e) {
                    ix.wr(" pp obj "+theFrame+" "+e);  // debug use only - not an error
               }
               
                if  (thereIsAnImageInPlace==false) {  // (theFrame.graphics.length <=0)
                        ix.wr("  pp  will need image import ");
                        ix.placeImage (myDoc, theFrame, rootFolder+imagePath);
                        //ix.postImportImage  (theFrame.id, rootFolder+imagePath);
                } else {
                    if (thereIsAnImageInPlace==true  && imList[i].@bean.toString() != "") {  //theFrame.graphics.length >0
                ix.wr("    pp relnk check "+imList[i].@bean.toString() );
                        if (ix.doGraphicsNeedRelink(theFrame.graphics,rootFolder+imagePath) ==true) {
                ix.wr("   pp  need reLink "+theFrame.graphics[0].id )
                            idlesRelink.push( {id:theFrame.graphics[0].id,linkPath:rootFolder+imagePath} );
                        }
                    }
                }
  
             } else {
                if (theFrame instanceof Rectangle) {   
                    try {
                        if (theFrame.graphics.length>0) {   // the frame has an image but the xml had no image path ...
                                 ix.removeAnObject(theFrame);
                                 theFrame = ix.createFrame (pageObj, topLeft, width, height);
                                 ix.flushTextFrame(theFrame);   
                                 theFrame.fillColor  = "None";  
                                 ix.saveTheXMLAttributes(theFrame,imList[i]);

                                 //theFrame = ReplaceWithTextFrame(theFrame);
                                  //theFrame.fillColor = "None";
                        }
                    } catch (e) {
                        ix.wr("ix.renderDoc exception reverting to text frame "+e);
                    }
                }
                var slugText = imList[i].@extra.toString();
                slugText = slugText.replace(/,/g,'\r');
                
                theFrame.texts[0].justification = Justification.CENTER_ALIGN;
                theFrame.fillColor = ix.backgroundColorSwatch; 
                theFrame.textFramePreferences.verticalJustification = VerticalJustification.CENTER_ALIGN;
                
                theFrame.parentStory.contents  = slugText;
            }
        
            if (imList[i].@locked==true) {
                  theFrame.locked=true;
            }
        
        } // end of for each image
        ix.removeDeadAdsAtOpen(pageObj, pageList[pageIndex].descendants('image'), pageIndex); 
    } // end of for each page

  //  ix.removeDeadAdsAtOpen(myDoc, xmlData.descendants('image') );     //??  to do

   // ix.wrLog(imList.length()+ " PlanPoint Ads Placed.");
    if (pageListDataForPlanPoint !="" ){
        idlesReturnOpenedPageList.push(pageListDataForPlanPoint);
    }

    ix.wrLog("Done");
}


ix.renderAd = function (myDoc, xmlData, pageIndex, rootFolder) {
    var theFrame = null;
    var id=0;
    var topLeft = {};
    var parent="";
    var adName="";
    
    var pageObj =  myDoc.pages.item(pageIndex);
    if (pageObj instanceof Page == false ) {
          ix.wr ("ix.renderAd invalid Page ref " +pageIndex);
          return;
    }

    xmlData.@application = ix.applicationName; // read from environment

   //ix.backgroundColorSwatch = ix.colorAdd (myDoc, "IX Light Gray", ColorModel.PROCESS, ColorSpace.RGB, [200, 200, 200]);
 

    // get resource attribute list & save list of att names in string array - store in "IX_ELEMENT_ATTRIBUTE_LIST"
    //  then store each att on doc with label = attribute name - so we can reconstruct the xml
    
    ix.saveTheXMLAttributes(myDoc,xmlData);
    
    // type="template" ?
    
    if (xmlData.@type=="template") {
        myDoc.documentPreferences.pageHeight = parseFloat(xmlData.@height);
        myDoc.documentPreferences.pageWidth  = parseFloat(xmlData.@width);
    }
    // bleed_bottom="0.0" bleed_inner="0.0" bleed_outer="0.0" bleed_top="0.0"
     if ( xmlData.@type=="template" && xmlData.@bleed_bottom != undefined && xmlData.@bleed_bottom !="" ) {
        myDoc.documentPreferences.documentBleedBottomOffset  = parseFloat(xmlData.@bleed_bottom);
        myDoc.documentPreferences.documentBleedInsideOrLeftOffset  = parseFloat(xmlData.@bleed_inner);
        myDoc.documentPreferences.documentBleedOutsideOrRightOffset  = parseFloat(xmlData.@ bleed_outer);
        myDoc.documentPreferences.documentBleedTopOffset = parseFloat(xmlData.@bleed_top);
     }
 
     parent = xmlData.@parent;
     adName = xmlData.@name;
     
    // set page number other meta data 
    
    var imList = xmlData.descendants('image');   // get list of image frame to make
    
    ix.wr("imList ="+imList);
    
    ix.wr(" renderAd xml image count ="+imList.length());
    
    // then create image frames and import images
    for (var i=0;i<imList.length();i++) {
        bean=0;
        topLeft = {};
        theFrame=null;
        
      try {
            id = parseInt(imList[i].@id.toString());
        } catch (e) {
            ix.wr("ix.renderAd invalid image bean "+ id);
            continue;
        }
      ix.wr(" renderAd id sought  ="+id+" "+id.constructor.name);
        theFrame = ix.findFrameById  (myDoc,id);
            
       //if (imList[i].@x == undefined ||  imList[i].@x=="" ) {
            
          
            if ( (id==0 ||  id=="" || theFrame== null || theFrame==undefined) && (imList[i].@x!="" && imList[i].@x!=undefined) ) {
                topLeft.x  = imList[i].@x.toString();
                topLeft.y  = imList[i].@y.toString();
                var width  = imList[i].@width.toString();
                var height = imList[i].@height.toString();
                theFrame = ix.createFrame (pageObj, topLeft, width, height);
                 ix.wr(" renderAd created this frame "+ theFrame);
            }
        
  ix.wr(" renderAd theFrame =" + theFrame+" "+id);      
  
            if (theFrame==null || theFrame==undefined ) continue;
     
            ix.saveTheXMLAttributes(theFrame,imList[i]);
        
            ix.flushTextFrame(theFrame);   
        
            var imagePath = imList[i].@path;
   ix.wr("      imagePath= "+ imagePath);     
            if ( imagePath !=""  && imagePath != undefined) {
                if (theFrame.graphics.length <=0) {
                ix.wr("     will need image import ");
                        //ix.placeImage (myDoc, theFrame, imagePath);
                        ix.postImportImage  (theFrame.id, rootFolder+imagePath);
                } else {
                    if (theFrame.graphics.length >0 && imList[i].@bean.toString() != "") {
                ix.wr("     relnk check "+imList[i].@bean.toString() );
                        if (ix.doGraphicsNeedRelink(theFrame.graphics,rootFolder+imagePath) ==true) {
                ix.wr("     need reLink "+theFrame.graphics[0].id )
                            idlesRelink.push( {id:theFrame.graphics[0].id,linkPath:rootFolder+imagePath} );
                        }
                    }
                }
            }
        
      //  }
    
    }  // end for loop

    idlesReturnOpenedAdList.push (parent+delim+adName);

    ix.wrLog(imList.length()+ " AdPoint images Seen.");
    ix.wrLog("Done");
    
}

/*
    
     if (item.graphics.length <= 0) continue;    
                     image = item.graphics[0];
                     var file = new File(image.itemLink.filePath);
                     
                     imagePath = file.fsName;
 */

ix.findFrameById = function (myLayoutObj,id) {
        var theFrame=null;
           try {
                if (id != 0) { 
                    theFrame = myLayoutObj.pageItems.itemByID(id).getElements()[0]; 
                    ix.wr (" my inner frame "+theFrame);
                }
           } catch (e) {
               ix.wr (" ix.findFrameById exception "+e);
           }
       
        if (theFrame instanceof Link==true) {
            try {
                theFrame = theFrame.parent.parent;
            } catch (e) {
                 ix.wr (" ix.findFrameById exception 2 "+e);
                 theFrame = null;
            }
       }
       
        return (theFrame);
}

ix.findFrameByBeanAndPage = function (myDoc, myPageObj, bean) {
  try {
    for ( var x = 0; x<myDoc.pageItems.length; x++ ) {
          var pageItem =  myDoc.pageItems[x].getElements()[0];
          var beanID = ix.getLabel (pageItem, "bean");
          if (beanID != -1 && beanID != ""  && beanID == bean) {
              ix.wr(" findFrameByBeanAndPage found by bean "+bean+" "+pageItem);
              ix.wr ("   check we are on same page by pageItem.parentPage.name vs myPageObj.name "+ pageItem.parentPage.name+" "+myPageObj.name);
              // check we are on same page
              if (pageItem.parentPage.name==myPageObj.name) {
                   return  pageItem;
             } else {
                   //
                   // if this is a spanning element - it may appear to be on a later page, but have left hand corner on this page
                   // so if found element is on a later page - take a look at its upper left hand corner 
                   // to see if its to the left of the gutter
                   //
                   if (parseInt (pageItem.parentPage.name,10) > parseInt (myPageObj.name,10)) {
                          var pt = pageItem.resolve(AnchorPoint.TOP_LEFT_ANCHOR,CoordinateSpaces.SPREAD_COORDINATES);
                          if (parseFloat(pt[0])<0) {
                                return  pageItem; // item is anchored on prev - hopefully this, page
                          }                     
                   }
             }
         }
    }
  } catch (e) {
      ix.wr("ix.findFrameByBeanAndPage exception "+e);
  }
    return  null;
}

ix.saveTheXMLAttributes = function ( obj, xmlElement ) {

   var aAtts = xmlElement.attributes();
   var aTmp=[];
   var containsID = false;
   
   for (var i=0; i< aAtts.length(); i++) {
         aTmp.push( aAtts[i].localName() );
         ix.setLabel (obj, aAtts[i].localName(), aAtts[i].toString());
         if(aAtts[i].localName() === 'id') {
         	containsID = true;
         }
   }
   if(containsID === false) {
   		ix.wr("setting id " + obj.id.toString());
   		ix.setLabel(obj, 'id', obj.id.toString());
   		aTmp.push('id');
   	}
    aTmp.sort();
    ix.setLabel (obj,"IX_ELEMENT_ATTRIBUTE_LIST", aTmp.join(";"));  // then set the list of attributes we set on the doc
}

ix.readTheXMLAttributesAsXMLString = function (obj, elementName ) {

   var attList = ix.getLabel (obj,"IX_ELEMENT_ATTRIBUTE_LIST"); // get the attribute list
   if (attList== -1 || attList == ""  || attList==undefined) {
       ix.wr ("readTheXMLAttributesAsXMLString - no attribute list "+obj+" "+ attList);
       return "";
   }
   var aTmp = attList.split(";");
   var tmpValue="";
  //  ix.wr(aTmp.constructor.name+" "+aTmp.length +"       "+attList.constructor.name+" "+attList);
   
   var expr = "<"+elementName+" ";
   for (var i=0; i<aTmp.length; i++) {
        tmpValue = ix.getLabel (obj, aTmp[i].toString() );  // beware getLabel returns of -1 or not found
        if ( tmpValue == -1 || tmpValue == '-1' ) tmpValue="";
        expr = expr+ aTmp[i] +'="'+tmpValue+'"  ' ;
   }  

   expr = expr + ">";
   
   ix.wr("ix.readTheXMLAttributesAsXMLString "+expr);
   
   //  6-5-16 
   expr = expr.replace("&amp;","&");  // make & in case any are entitied
   expr = expr.replace("&","&amp;");   // then convert all & to &amp;
   
   return (expr);

}



ix.importPostedImageToDoc = function (myDoc, frameID, imagePath)  {

    app.activate();
    var frame = null;
    ix.wr("ix.importPostedImageToDoc " +myDoc+" "+frameID+" "+imagePath);
    myDoc.save();
   try {
        frame = myDoc.pageItems.itemByID(parseInt(frameID,10)).getElements()[0];
   } catch (e) {
        ix.wr("ix.importPostedImageToDoc 1 "+e+" "+frame);
        return;
   }
   
    //app.select(frame);
    try {
        ix.placeImage (myDoc, frame, imagePath);    
   } catch (e) {
        ix.wr("ix.importPostedImageToDoc 2 "+e+" "+frame);
        return;
   }   
    // re-find frame after place - 4-26-16
    try {
        frame = myDoc.pageItems.itemByID(parseInt(frameID,10)).getElements()[0];
   } catch (e) {
        ix.wr("ix.importPostedImageToDoc 3 "+e+" "+frame);
        return;
   }  

    if (doDeleteCheck) { ix.attachDeleteCheckToOneImage(frame); }
}


ix.importPostedImage = function (frameID, imagePath)  {

    app.activate();
    var frame = null;
    ix.wr("ix.importPostedImage " +frameID+" "+imagePath);
    
   try {
        frame = app.activeDocument.pageItems.itemByID(parseInt(frameID,10)).getElements()[0];
   } catch (e) {
        ix.wr("ix.importPostedImage 1 "+e+" "+frame);
        return;
   }
   
    //app.select(frame);
    try {
        ix.placeImage (app.activeDocument, frame, imagePath);    
   } catch (e) {
        ix.wr("ix.importPostedImage 2 "+e+" "+frame);
        return;
   }   
    // re-find frame after place - 4-26-16
    try {
        frame = app.activeDocument.pageItems.itemByID(parseInt(frameID,10)).getElements()[0];
   } catch (e) {
        ix.wr("ix.importPostedImage 3 "+e+" "+frame);
        return;
   }  

    if (doDeleteCheck) { ix.attachDeleteCheckToOneImage(frame); }
}

ix.postImportImage = function (id,path) {
        ix.wr ("postImportImage " +id +" "+path);              // log to file as well
     try {                                                                  // 4-26-15
            ix.xLib = new ExternalObject("lib:\PlugPlugExternalObject");
        } catch (e) {
            ix.wr (" ix:ExternalObject: "+e);
      }      
        if (ix.xLib !=null) {
            var eventObj = new CSXSEvent(); 
            eventObj.type = "IXIMPORTIMAGEPOST";
            eventObj.data = id+"%"+path;
            eventObj.dispatch();
        }
}

// myDoc.pages.item(pageIndex)

ix.createFrame = function(page,topLeft,width,height) {
  // ix.wr("ix.createFrame args = "+page+" "+topLeft.toSource()+" "+width+" "+height);

  if (page instanceof Page == false || page.isValid==false) {
      $.bp(true);
  }
   
  var retVal = null;
  try
  {
    retVal = page.textFrames.add();
    var y2 = parseFloat(topLeft.y) + parseFloat(height);   
    var x2 = parseFloat(topLeft.x) + parseFloat(width);
    retVal.geometricBounds = [topLeft.y, topLeft.x, y2, x2];
    //ix.wr ("ix.createFrame  y1 x1 y2 x2 ="+topLeft.y+" "+topLeft.x+" "+y2+" "+x2);
  }
  catch(err)
  {
     ix.wr("ix.createFrame exception "+err);
    if (retVal != null)
    {
      retVal.remove();
    }
    retVal = null;
  }
  return retVal;                                      
}


ix.resetFrame = function (frame,topLeft,width,height){

      ix.wr("ix.resetFrame args = "+frame+" "+topLeft.toSource()+" "+width+" "+height);
      
      try {
                    //var movX =  frame.geometricBounds[1] - parseFloat(topLeft.x);
                   // var movY =  frame.geometricBounds[0] - parseFloat(topLeft.y);
                    //movX = ix.doRounding (movX,3);
                    //movY = ix.doRounding (movY,3);
                    //ix.wr("ix.resetFrame move = "+movX+" "+movY);
            var saveLockState=frame.locked;
            frame.locked = false;
            frame.move([topLeft.x,topLeft.y]);   // use move to variation
            frame.locked = saveLockState;
                    //var y2 = parseFloat(topLeft.y) + parseFloat(height);   
                    //var x2 = parseFloat(topLeft.x) + parseFloat(width);
                    //frame.geometricBounds = [topLeft.y, topLeft.x, y2, x2];
                    //ix.wr ("ix.resetFrame  y1 x1 y2 x2 ="+topLeft.y+" "+topLeft.x+" "+y2+" "+x2);
        
      }  catch(err) {
         ix.wr("ix.resetFrame exception "+err+" "+frame);
      }
      return frame;                                      
}


ix.placeImage = function (myDoc, in_portrait_frame, in_imagePath) {
      var result=true;
      var saveLockState=false;
     ix.wr(" placeImage: "+in_imagePath);
     var imageFile = new File (in_imagePath);
    do {
            var frame = in_portrait_frame;    //in_document.pageItems.itemByID(id).getElements()[0];
            try {
                saveLockState = frame.locked;
                frame.locked = false;
                if (! imageFile.exists) {
                    ix.wr("placeImage image missing :"+in_imagePath);
                    result = false;
                } else {
                    var image = frame.place(imageFile);
               
                //ix.fitImage(frame);        
                }
                frame.locked = saveLockState;
        } catch (e) {
                ix.wr("placeImage exception "+e);
                result = false;
                break;
        }
  } while (false);
  
  return result;
}

ix.setCoordSchemeToSpread=function(myDoc) {
     // lets work in points
    ix.savedDocUnits = 
	{
		horizontal: myDoc.viewPreferences.horizontalMeasurementUnits,
		vertical: myDoc.viewPreferences.verticalMeasurementUnits
	};
    ix.savedZero=myDoc.zeroPoint;
    ix.savedViewRulerOrigin = myDoc.viewPreferences.rulerOrigin;
    
    myDoc.zeroPoint = [0,0];  
	myDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	myDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
    
    //myDoc.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
    
    myDoc.viewPreferences.rulerOrigin = RulerOrigin.SPREAD_ORIGIN;
}

ix.setCoordSchemeToPage=function(myDoc,pageIndex) {
     // lets work in mm
    ix.savedDocUnits = 
	{
		horizontal: myDoc.viewPreferences.horizontalMeasurementUnits,
		vertical: myDoc.viewPreferences.verticalMeasurementUnits
	};
    ix.savedZero=myDoc.zeroPoint;
    ix.savedViewRulerOrigin = myDoc.viewPreferences.rulerOrigin;
     
    myDoc.zeroPoint = [0,0]; 
	myDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	myDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
    
    //myDoc.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;

    myDoc.viewPreferences.rulerOrigin = RulerOrigin.pageOrigin;
}

ix.restoreCoordScheme=function(myDoc) {
    myDoc.viewPreferences.rulerOrigin = ix.savedViewRulerOrigin;
    myDoc.viewPreferences.horizontalMeasurementUnits = ix.savedDocUnits.horizontal;
    myDoc.viewPreferences.verticalMeasurementUnits = ix.savedDocUnits.vertical;
    myDoc.zeroPoint=ix.savedZero;
}

ix.wrLog = function (text,clear) {        
        if (ix.xLib != null) {
            var eventObj = new CSXSEvent(); 
            eventObj.type = "IXLOG";
            if (clear==true)  eventObj.data = "CLEAR";
            else eventObj.data = text;
            eventObj.dispatch();
        }
}

ix.tell_JS = function (text) {
       ix.wr ("ix.tell_JS "+text);  
      if (ix.xLib != null) {
            var eventObj = new CSXSEvent(); 
            eventObj.type = "IXMSG";
            eventObj.data = text;
            eventObj.dispatch();
      }
}



var TIME_TO_PROGRESS=5000;

ix.testProgress = function (numSecs) {
    if (numSecs!=undefined ) {
        TIME_TO_PROGRESS=(parseInt(numSecs,10)*1000);
    }
    var start = new Date().getTime();
    var endTime = start + TIME_TO_PROGRESS;
    ix.newProgress(TIME_TO_PROGRESS,"Progress Or Not");

    var now = new Date().getTime();
    while ( now < endTime) {
        
        ix.setProgress(now-start);
        now = new Date().getTime();
    }
    ix.closeProgress();
}


ix.newProgress = function (maxval, str) {
    ix.pBarMax = maxval + 1;
    ix.pb_win = new Window('palette', str);
    ix.pbar = ix.pb_win.add('progressbar', undefined, 1, ix.pBarMax);
    ix.pbar.preferredSize = [300, 20];
    ix.pbar.value = 0;
    ix.pb_win.show();
};

ix.incProgress = function() {
    ix.pbar.value = ix.pbar.value + 1;
  
};

ix.setProgress = function(val) {
    ix.pbar.value =val;
};


ix.closeProgress = function () {
    try {
        ix.pb_win.close();
    }
    catch (e) {
       ix.wr("ix.closeProgress "+e);
    }
};




ix.getFolderPath= function (promptString)
{
		var theFolder=null;
		theFolder = Folder.selectDialog (promptString);
		if (theFolder==null) return "";
		return (ix.ensurePathEndsInSlash(theFolder.fsName)); //was  absoluteURI
}

ix.getFolderNameFromPath=function(path) {
        var fldr = Folder(path);
        return (fldr.name);
}

ix.getPlatform= function () {
    var os = Folder.fs;
    if (os.indexOf("Windows")>=0)
         return "WIN";   
    else
         return "MAC";
}

ix.ensurePathEndsInSlash =function (myPath) {
            myPath=myPath.toString();
		    if (ix.getPlatform()=="MAC") {
				if (myPath.charAt(myPath.length - 1) == "/") {} else {myPath =myPath+"/";}
			} else {
				if (myPath.charAt(myPath.length - 1) == "\\"){} else {myPath =myPath+"\\";}
			}
			return myPath;
}



ix.doAlert=function(msg) {
    alert (msg);
    ix.wr("ix.alert :"+msg);
}

ix.prompt=function (p,d,t) {
       
       var aTmp =ix._makeDlog(p,d,t);
       var nameDialog = aTmp[0]; 
       var myNameField =aTmp[1] ;
       var  msgBox = aTmp[2] ;           
       
       ix.wr("ix.prompt: "+p+" "+d+" "+t);
                                            
       var rtn = nameDialog.show();  
       if (rtn==null || rtn == false) rtn=""; // make all rtns strings
       else  {
           rtn = myNameField.editContents; 
         //  rtn = ix.cleanName (rtn);   // no funny stuff
       }
       return rtn;
}

ix.confirm = function (msg,title) {
    var resp = confirm (msg, true, title);
    ix.wr ("ix.confrim: "+msg+" responded: "+resp);
    return(resp);
}



 
 
ix._makeDlog = function (msgText,sName,atitle){
    
        var arr = new Array(3);    
    
        var nameDialog = app.dialogs.add({name:atitle});
        var msgBox = null;
        var myEditField = null;

        with(nameDialog.dialogColumns.add())
        {
              with(dialogRows.add())
              { 
                    staticTexts.add({staticLabel:msgText});
                    myEditField = textEditboxes.add({editContents:sName,minWidth:140}); //?
                        
               }
             with(dialogRows.add())
              { 
                        msgBox=staticTexts.add({msg:":",minWidth:200});
                   }
        }

        //msgBox.staticLabel=msgText2;
        nameDialog.dialogColumns.add();
        arr[0] = nameDialog; 
        arr[1] = myEditField;
        arr[2] = msgBox;
        
        return (arr);
 }


ix.writeTextToXMLFile=function (thisPath,fileDescription,xmlString) {
	 
	if (thisPath==null || thisPath=="")
	{
		var myWriteFile = File.openDialog ("Locate "+fileDescription+" File ", "XML file:*.xml", false);
	}
	else
	{
		var myWriteFile = new File(thisPath);
		if (myWriteFile==null)
		{
			ix.wr  (fileDescription+"  file object failure: "+File.decode(thisPath));
			return (false);
		}
		myWriteFile.encoding = "UTF-8";
		if (myWriteFile.name.toString().toLowerCase().indexOf(".xml")<=0) 
		{
				ix.wr (myWriteFile.name+ " is wrong file type.");
				return false;
		}
		if(myWriteFile.open('w')!=true)
		{
			ix.wr ("Failed to open for write "+fileDescription+" file");
			return (false);
		}
    
		if (myWriteFile.write(xmlString)==false)   
		{
			ix.wr ("Failed to write "+fileDescription+" file");
			myWriteFile.close();
			return (false);
		}
		myWriteFile.close();		
		return (true);
	}
}



ix.readFileIntoXML = function(thisPath,fileDescription)
{
	 
	if (thisPath==null || thisPath=="")
	{
		var myReadFile = File.openDialog ("Locate "+fileDescription+" File ", "XML file:*.xml", false);
	}
	else
	{
		var myReadFile = new File(thisPath);
		if (myReadFile.exists==false)
		{
			ix.wr  (fileDescription+"  file does not exist: "+File.decode(thisPath));
			return (null);
		}
	}
		if (myReadFile != null)
		{
			myReadFile.encoding = "UTF-8";
          
			if (myReadFile.name.toString().toLowerCase().indexOf(".xml")<=0) 
			{
					ix.wr (myReadFile.name+ " is wrong file type.");
					return null;
			}
			if(myReadFile.open('r')!=true)
			{
				ix.wr ("Failed to read "+fileDescription+" file");
				return (null);
			}
			var rBuf = myReadFile.read();
			myReadFile.close();
			
			try {
                XML.prettyPrinting=false;  // important !!  do not undo this line !!  pjb  
                XML.ignoreComments=true;
                XML.ignoreWhitespace=false;
                XML.ignoreProcessingInstructions=true;
				var xmlData = XML(rBuf);
			}
			catch (e)
			{
				ix.wr (fileDescription+" xml file format error "+e);
				return (null);
			}
			
			
		}
	return(xmlData);
}

ix.searchAndReplace =  function (matchString, replaceString) {

	try{
		app.findTextPreferences = NothingEnum.nothing;
		app.changeTextPreferences = NothingEnum.nothing;
        
		//Set the find options.
		app.findChangeTextOptions.caseSensitive = true;
		app.findChangeTextOptions.includeFootnotes = false;
		app.findChangeTextOptions.includeHiddenLayers = false;
		app.findChangeTextOptions.includeLockedLayersForFind = false;
		app.findChangeTextOptions.includeLockedStoriesForFind = false;
		app.findChangeTextOptions.includeMasterPages = true;   
		app.findChangeTextOptions.wholeWord = false;
        
		//Search the document for the string  
		app.findTextPreferences.findWhat = matchString;
		app.changeTextPreferences.changeTo = replaceString;
        
		//allMyFinds = app.documents.item(0).findText();
		app.documents.item(0).changeText();

		//Clear the find/change preferences after the search.
		app.findTextPreferences = NothingEnum.nothing;
		app.changeTextPreferences = NothingEnum.nothing;
	}
	catch (e)
	{
		ix.wr("ix.searchAndReplace "+e);
				 
	}
	
}


ix.searchAndReplaceOnThisPage =  function (myDoc, matchString, replaceString,thisPageObj) {

	var allMyFinds=[];
    var cnt =0;
    try{
            app.findTextPreferences = NothingEnum.nothing;
            app.changeTextPreferences = NothingEnum.nothing;
            //Set the find options.
            app.findChangeTextOptions.caseSensitive = true;
            app.findChangeTextOptions.includeFootnotes = false;
            app.findChangeTextOptions.includeHiddenLayers = false;
            app.findChangeTextOptions.includeLockedLayersForFind = false;
            app.findChangeTextOptions.includeLockedStoriesForFind = false;
            app.findChangeTextOptions.includeMasterPages = true; 
            app.findChangeTextOptions.wholeWord = false;
            //Search the document for the string  
            app.findTextPreferences.findWhat = matchString;
            app.changeTextPreferences.changeTo = "";
            allMyFinds = myDoc.findText();
        } catch (e) {
                    ix.wr("ix.searchAndReplaceOnThisPage find exception "+e);
        }
    
        for (var i=0; i<allMyFinds.length; i++) {
            try {
                
                var page = ix.storyToPage(allMyFinds[i].parentStory);
                if (page==null) { $.bp(true); }
                 ix.wr(page.id+" ? "+thisPageObj.id); 
// ix.itemIsOnMyMasterPage(myPage, frameItem);
// 
if (page != null && (thisPageObj.id == page.id ||  ix.itemIsOnMyMasterPage(thisPageObj, ix.storyToTextFrame(allMyFinds[i].parentStory)) ) ) { //allMyFinds[i].parentStory.textFrames[0].parentPage.id) {
                          ix.wr("match "+matchString+" "+ replaceString);
                          var tmpstr = allMyFinds[i].contents;
                          tmpstr = tmpstr.replace(matchString,replaceString);
                          allMyFinds[i].contents=tmpstr;
                }
            } catch (e) {
                ix.wr("ix.searchAndReplaceOnThisPage replace exception "+e);
                ix.wr(thisPageObj.id);
                ix.wr(allMyFinds[i]);
                ix.wr(allMyFinds[i].parentStory);
             }
        }
    
    
        return ;
	
}

ix.saveDateInfo = function (weekday,year,month,day ) {
  ix.weekday=weekday;
  ix.day=day;
  ix.month=month;
  ix.year=year;
}


ix.handleExports = function (option, clientID, applicationName, action) {

    ix.wr("ix.handleExports "+option+" "+clientID+" "+applicationName+" "+action);

    var rtnPath=""
    var docType = ix.getFrontDocType ();
    if (docType=="PlanPoint") {
        if (option == "SaveOnly" || option== "SaveTemplate") {
            ix.doAlert ("Not a PlanPoint Option");
            return ("");
        }
        rtnPath = ix.exportToPlanPoint (option, clientID, applicationName, action);
    }
    if (docType=="AdPoint") {
        rtnPath = ix.exportToAdPoint (option, clientID, applicationName, action);
    }
    return (rtnPath+"$"+docType);
}

ix.exportToPlanPoint = function (option, clientID, applicationName,action) {

   var isNewFrame=false;
   var imageElementXmlString = "<image bean='' height='' id='' width='' x='' y=''/>";
   var pageElementXmlString  = "<page absolute_page_number='' department='' description='' edition='' editorialdepartment='' latest_note='' margin_bottom='' margin_left='' margin_right='' margin_top='' materialid='' name='' page_number='' parent='' product='' publication_date='' section='' viewonly='' zone='' />";
   var item = null;
   var tmpstr= "";
   var image = null;
   var imagePath = "";
   var newItem = false;
   var thisPageObj=null;
   var pageIndex=0;
   var xmlPageElementPile=[];
   var itemAnchoredOnPreviousPage=false;
   
    ix.wr("ix.exportToPlanPoint "+option);
    
    try {
      var myDoc = app.activeDocument ;
    } catch (e) {
        return false;
    }
    
    
    if (myDoc instanceof Document == false) {
         ix.wrLog(" No documents open to export ");
         return;
    }


   // var parent = ix.getLabel(myDoc,"parent");
    var docType = ix.getLabel (myDoc, "docType");
    if (docType==-1 || docType == ""  || docType!="PlanPoint") {
         ix.wrLog(" Can't export. Not a PlanPoint document.  docType="+docType);
         return;
    }

    myDoc.save();

    ix.setCoordSchemeToPage (myDoc,0);
               
    var xmlStr = "";   //'<?xml version="1.0" encoding="UTF-8" standalone="no"?>';
    
    xmlStr = xmlStr+ ix.readTheXMLAttributesAsXMLString (myDoc,"request");
    
   
     // for each page
     for (pageIndex=0,xmlPageElement=null; pageIndex<myDoc.pages.length; pageIndex++) {
         var anAddedPage =  false;
         thisPageObj =  myDoc.pages.item (pageIndex);
         if (thisPageObj instanceof Page == false ) {
             ix.wr ("ix.renderDoc invalid Page ref " +pageIndex);
             continue;
         }       
         
        tmpstr = ix.readTheXMLAttributesAsXMLString (thisPageObj,"page");
        
        if (tmpstr=="") {
            tmpstr = pageElementXmlString;
            anAddedPage = true;
        }
    
        try {
            var xmlPageElement = new XML(tmpstr);
         } catch (e) {
             ix.wr (" exportToPlanPoint make xml error "+e+" "+tmpstr);
         }
     
     
        if (anAddedPage==true) {
            xmlPageElement.@page_number = thisPageObj.name;
            var pageXmlString = findSomePageXmlData (myDoc);
            if (pageXmlString !=""){
                try {
                    var xmlTmp = new XML(pageXmlString);
                    xmlPageElement.@materialid = xmlTmp.@materialid;
                } catch (e) {
                    ;
                }
            }
        }
     
        //xmlPageElement.@height  = ix.doRounding(parseFloat(myDoc.documentPreferences.pageHeight),2);
        //xmlPageElement.@width   = ix.doRounding(parseFloat(myDoc.documentPreferences.pageWidth),2);
         
        tmpstr="";
    
       // for each ad
        for (var y=0; y<thisPageObj.pageItems.length; y++) {
                itemAnchoredOnPreviousPage=false;
                newItem = false;
                imagePath="";
                image=null;
                item = thisPageObj.pageItems[y].getElements()[0];
                   ix.wr(" exportToPlanPoint found "+ item+"  id="+item.id);
               if ( item instanceof Rectangle  || item instanceof TextFrame ) {  
                   
                     tmpstr = ix.readTheXMLAttributesAsXMLString (item,"image");
                     if (tmpstr=="") {
                          if (item instanceof TextFrame == true) continue;
                          
                         if (ix.itemIsOnAnotherMasterPage (myDoc,item)==true) continue;  // not our item
                          
                        ix.wr(" new  unregistered graphic item found");
                          tmpstr = imageElementXmlString;
                         try {
                             if (item.graphics.length <= 0) continue;    
                             image = item.graphics[0];
                             var file = new File(image.itemLink.filePath);
                             imagePath = file.fsName;
                             
                                                          ix.wr(" new  unregistered graphic item "+imagePath);

                             newItem = true;
                          
                          } catch (e) {
                              ix.wr(" graphic item exception  "+e);
                          }
                    } else {
                        if ( item instanceof Rectangle) {
                         if (item.graphics.length > 0) {
                                 try {
                                    image = item.graphics[0];
                                    var theFile = new File(image.itemLink.filePath);
                                    imagePath = theFile.fsName;
                                 } catch (e) {
                                     ix.wr(" graphic item exception 2  "+e);
                                 }
                             }
                         }
                    }
                
                     try {
                        var xmlElement = new XML(tmpstr);
                     } catch (e) {
                         ix.wr (" exportToPlanPoint make xml error "+e+" "+tmpstr);
                     }
                 
                       // for all items - always refresh element data for path, position and size.
                       
                     xmlElement.@y = ix.doRounding( item.geometricBounds[0],2 );    // [topLeft.y, topLeft.x, y2, x2];
                     xmlElement.@x = ix.doRounding( item.geometricBounds[1],2 );
                     xmlElement.@height    = ix.doRounding ( item.geometricBounds[2]-item.geometricBounds[0],2 );
                     xmlElement.@width     = ix.doRounding( item.geometricBounds[3]-item.geometricBounds[1],2 );
                     xmlElement.@id = item.id;
                     xmlElement.@path = imagePath;
                     
                    if ( pageIndex>0 ) {
                          var pt = item.resolve(AnchorPoint.TOP_LEFT_ANCHOR,CoordinateSpaces.SPREAD_COORDINATES);
                          if (parseFloat(pt[0])<0) {
                              itemAnchoredOnPreviousPage=true;
                          }
                    }
                
                    if (itemAnchoredOnPreviousPage==true && pageIndex>0) {
                        xmlPageElementPile[pageIndex-1].appendChild(xmlElement);
                    } else {
                        xmlPageElement.appendChild(xmlElement);
                    }
                     
                     //xmlStr = xmlStr+ xmlElement.toXMLString();
               }  // end of if rectangle
                  
            } // end of for each ad element
        
            //xmlStr = xmlStr+ xmlPageElement.toXMLString();        
            
            xmlPageElementPile[pageIndex]=xmlPageElement;  // defer stringify till all done

        
        } // end of for each page 
    
        // render the xml page sructures to xml strings
        for (var g=0; g<xmlPageElementPile.length; g++) {
            xmlStr = xmlStr + xmlPageElementPile[g].toXMLString();
        }
        xmlStr = xmlStr+ "</request>";
        
        
        
          ix.restoreCoordScheme(myDoc);

        
          
          var myDocsFileObj = new File(myDoc.fullName);
              
          var myDocsFolderPath = ix.ensurePathEndsInSlash(myDocsFileObj.parent.fsName);
                 
          var myXmlDocName = myDoc.name.replace(".indd","");
          myXmlDocName = myXmlDocName.replace(".INDD","");
          myXmlDocName = myXmlDocName+"_saved.xml";
          myPdfDocName =myDoc.name.replace(".indd","")+".pdf";

          //if (xmlStr.indexOf('cid=')>0 ) bt.wr("ix.exportToPlanPoint error cid duplicated in xml");
          
          try {
              var newXmlObj = new XML (xmlStr);
          } catch (e) {
              alert ("ix.exportToPlanPoint xml sytax error - see Integration-X client log file "+e);
              return false;
          }
      
          try {
              newXmlObj.@cid = clientID;
              newXmlObj.@application = applicationName;
              newXmlObj.@action = action;
              newXmlObj.@pdfpath = (myDocsFolderPath+myPdfDocName).toString();
              newXmlObj.@path = (myDocsFolderPath+myDoc.name).toString();
          } catch (e) {
              alert ("ix.exportToPlanPoint xml sytax error 2 - see Integration-X client log file "+e);
              return false;
          }
          
        //xmlStr = xmlStr.replace("<request", "<request cid='" + clientID + "' action='save' pdfpath='"+myDocsFolderPath+myPdfDocName+"' path='" + (myDocsFolderPath+myXmlDocName) + "'");
          
          // write out XML to a file
          ix.writeTextToXMLFile  (myDocsFolderPath+myXmlDocName, "Exported XML", newXmlObj.toXMLString());
          
          ix.wrLog(" Exporting "+myXmlDocName);

         // export PDF  
         var pdfPreSet = app.pdfExportPresets[0]; //app.pdfExportPresets.item('[HighQualityPrint]');     
         
         if ( pdfPreSet == null ||  pdfPreSet.isValid==false){  
              ix.wr ('PDF Export Presets not found');  
              return false;
         }  
         
         app.pdfExportPreferences.pageRange = PageRange.ALL_PAGES;    
 
         if (option == "SaveAndExport") {        
         	myDoc.exportFile (ExportFormat.PDF_TYPE, new File(myDocsFolderPath+myPdfDocName), false,  pdfPreSet);    
        	ix.wrLog(" Exporting "+myPdfDocName);
         }
         if (option == "SaveAndExportCustomPP") {                 
         	myDoc.exportFile (ExportFormat.PDF_TYPE, new File(myDocsFolderPath+myPdfDocName), true,  pdfPreSet);    
        	ix.wrLog(" Exporting "+myPdfDocName);
         }
         
        // myDoc.exportFile (ExportFormat.PDF_TYPE, new File(myDocsFolderPath+myPdfDocName), true,  pdfPreSet); 
        
         ix.wrLog(" Exporting "+myPdfDocName);
          
         return (myDocsFolderPath+myXmlDocName) ;
         
         //return myDocsFolderPath+"$"+myXmlDocName + "$" + myDoc.name+"$"+myDocsFolderPath+myPdfDocName;
}


ix.exportToAdPoint = function (option, clientID, applicationName, action) {

   var isNewFrame=false;
   var imageElementXmlString = '<image bean="" height="" id="" width="" x="" y=""/>';
   var item = null;
   var tmpstr= "";
   var image = null;
   var imagePath = "";
   var newItem = false;
   
   
    ix.wr("ix.exportToAdPoint "+option);
    
    
    try {
      var myDoc = app.activeDocument ;
    } catch (e) {
        return false;
    }
    
    
    if (myDoc instanceof Document == false) {
         ix.wrLog(" No documents open to export ");
         return;
    }


    var parent = ix.getLabel(myDoc,"parent");
    if (parent==-1 || parent == "" ) {
         ix.wrLog(" Can't export. Not a AdPoint document. ");
         return;
    }

    myDoc.save();

    ix.setCoordSchemeToPage (myDoc,0);
               
    var xmlStr = "";//'<?xml version="1.0" encoding="UTF-8" standalone="no"?>';
    
    xmlStr = xmlStr+ ix.readTheXMLAttributesAsXMLString (myDoc,"request");
    
    for (var y=0; y<myDoc.pageItems.length; y++) {
    	newItem = false;
        imagePath="";
        image=null;
        item = myDoc.pageItems[y].getElements()[0];
           ix.wr(" exportToAdPoint found "+ item);
       if ( item instanceof Rectangle  || item instanceof TextFrame || item instanceof Polygon ) { //
           
             tmpstr = ix.readTheXMLAttributesAsXMLString (item,"image");
             if (tmpstr=="") {
                  if (item instanceof TextFrame == true) continue;  // ignore - text frame
                  
                 if (ix.itemIsOnAnotherMasterPage (myDoc,item)==true) continue;  // ignore - not our item
                  
             	ix.wr(" new  unregistered graphic item found at (y,x) "+ix.doRounding( item.geometricBounds[0],2 )+","+ix.doRounding( item.geometricBounds[1],2 ));
                  tmpstr = imageElementXmlString;
                 try {
                     if (item.graphics.length <= 0) {
                         ix.wr(" empty frame ");
                     	continue;    // ignore - empty frame
                     }
                     image = item.graphics[0];
                     var file = new File(image.itemLink.filePath);
                     
                     imagePath = file.fsName;
                     newItem = true;
                  
                  } catch (e) {
                      ix.wr(" graphic item exception  "+e);
                  }
            } else {
                 if (item.graphics.length > 0) {
                     try {
                        image = item.graphics[0];
                        var theFile = new File(image.itemLink.filePath);
                        imagePath = theFile.fsName;
                     } catch (e) {
                         ix.wr(" graphic item exception 2  "+e);
                     }
                 }
            }
        
             try {
                var xmlElement = new XML(tmpstr);
             } catch (e) {
                 ix.wr (" exportToAdPoint make xml error "+e+" "+tmpstr);
             }
         
             // for all items - always refresh element data for path, position and size.
             
             xmlElement.@y = ix.doRounding( item.geometricBounds[0],2 );    // [topLeft.y, topLeft.x, y2, x2];
             xmlElement.@x = ix.doRounding( item.geometricBounds[1],2 );
             xmlElement.@height    = ix.doRounding ( item.geometricBounds[2]-item.geometricBounds[0],2 );
             xmlElement.@width     = ix.doRounding( item.geometricBounds[3]-item.geometricBounds[1],2 );
             xmlElement.@id = item.id;
             xmlElement.@path = imagePath;
                                                   //if(newItem === true) {
                                                   //}
             xmlStr = xmlStr+ xmlElement.toXMLString();
             ix.wr ("   add    "+xmlElement.toXMLString());
       }
    }

          ix.restoreCoordScheme(myDoc);

          xmlStr = xmlStr+ "</request>";
          
          var myDocsFileObj = new File(myDoc.fullName);
              
          var myDocsFolderPath = ix.ensurePathEndsInSlash(myDocsFileObj.parent.fsName);
                 
          var myXmlDocName = myDoc.name.replace(".indd","");
          myXmlDocName = myXmlDocName.replace(".INDD","");
          myXmlDocName = myXmlDocName+"_saved.xml";
          myPdfDocName = myDoc.name.replace(".indd","")+".pdf";

          
          try {
              var newXmlObj = new XML (xmlStr);
          } catch (e) {
              alert ("ix.exportToAdPoint xml sytax error - see Integration-X client log file "+e);
              return false;
          }
      
          try {
              newXmlObj.@cid = clientID;
              newXmlObj.@application = applicationName;
              newXmlObj.@action = action;
              if (option=="SaveOnly" || option=="SaveTemplate" || option == "SaveClose") {
                  newXmlObj.@pdfpath ="";
              } else {
              	newXmlObj.@pdfpath = (myDocsFolderPath+myPdfDocName).toString();
              }
              newXmlObj.@path = (myDocsFolderPath+myDoc.name).toString();
              if (option =="SaveTemplate") {
              	newXmlObj.@materialid = "";
              	newXmlObj.@type = 'template'
              }
          } catch (e) {
              alert ("ix.exportToAdPoint xml sytax error 2 - see Integration-X client log file "+e);
              return false;
          }
           
          try {
             var pdfProfilePath = newXmlObj.@defaultpdfprofile;
               ix.wr ("exportToAdPoint pdf profile "+pdfProfilePath);
           } catch (e) {
               ix.wr ("exportToAdPoint "+e);
             var pdfProfilePath="";
           }
            //xmlStr = xmlStr.replace("<request", "<request cid='" + clientID + "' action='save' pdfpath='"+myDocsFolderPath+myPdfDocName+"' path='" + (myDocsFolderPath+myXmlDocName) + "'");
          
          // write out XML to a file
          ix.writeTextToXMLFile  (myDocsFolderPath+myXmlDocName, "Exported XML", newXmlObj.toXMLString());
          
          ix.wrLog(" Exporting "+myXmlDocName);

         // export PDF  
         var pdfPreSet = app.pdfExportPresets[0]; //app.pdfExportPresets.item('[HighQualityPrint]');     
         
         if ( pdfPreSet == null ||  pdfPreSet.isValid==false){  
              ix.wr ('PDF Export Presets not found');  
              exit ();  
         }  
         
         app.pdfExportPreferences.pageRange = PageRange.ALL_PAGES;   
         if (option == "SaveAndExport") {                 
            if (pdfProfilePath != undefined && pdfProfilePath!="") {
                 var tmp = ix.loadPDFPreset (pdfProfilePath);
                 if (tmp != null) {
                     pdfPreSet = tmp;
                 } else {
                     ix.wr(" loadPDFPreset failed "+pdfProfilePath);
                 }
            }
            myDoc.exportFile (ExportFormat.PDF_TYPE, new File(myDocsFolderPath+myPdfDocName), false,  pdfPreSet);    
        	ix.wrLog(" Exporting "+myPdfDocName+" using the "+pdfPreSet.name+" profile");
         }
     
         if (option == "SaveAndExportCustom") {                 
         	myDoc.exportFile (ExportFormat.PDF_TYPE, new File(myDocsFolderPath+myPdfDocName), true,  pdfPreSet);    
        	ix.wrLog(" Exporting "+myPdfDocName);
         }
          
         return (myDocsFolderPath+myXmlDocName) ;
}
 
 
 
 
ix.getLabel = function(obj,labelName) {
    var rtn = -1;
    try {
        var t = obj.extractLabel (labelName);
       //  ix.wr ("           getLabel() "+obj+" "+labelName+" = "+t);
        if (t==undefined || t==null  || t=="") t= -1;
         return t;
    } catch (e) {
         ix.wr ("getLabel() "+e+" "+obj+" "+labelName);
    }
   return rtn;
};

ix.setLabel = function(obj,labelName,val) {
    try {
          if (val==undefined || val==null  || val=="") t=null;
          val = val.toString(); // just to be sure
          obj.insertLabel(labelName,val);
        //  ix.wr ("           setLabel() "+obj+" "+labelName+" = "+val);
    } catch (e) {
         ix.wr ("setLabel() "+e+" "+obj+" "+labelName);
    }
}

/* round */    
ix.doRounding = function (number, digits) {    
        digits = (digits) ? Math.pow(10, digits) : 1000;      
        return Math.round(number * digits) / digits;      
}   
/* resize object */   
ix.resizeItem = function (mItem, mWidth,mHeight) {  
    var mBounds = mItem.geometricBounds;  
    mBounds[3] = mBounds[1] + mWidth;  
    mBounds[2] =mBounds[0] + mHeight;  
    mItem.geometricBounds = mBounds;   
} 


// --------- IX logging--------------

ix.logF = null;
ix.wr=function(str)
{
	var d = new Date();
	
	if (ix.logF==null)
	{
		ix.logfile_open(ix.ensurePathEndsInSlash(Folder.myDocuments.fsName)+"Integration-X_LogFile.txt");
		ix.logF.writeln("Integration-X_LogFile_" + new Date().format("yyyyMMddhmmss") + ".txt")
         ix.logF.writeln ("js version: "+ix.version);
         ix.pruneOldLogFiles();
	}
	if (ix.logF!=null) { 
        ix.logF.writeln (d.toLocaleString()+ " "+str);
        if (ix.debug==true) {
           //$.writeln(str); // comment out before compiling !
        }
    }
}

var LOGFILELIMIT = 5;
ix.pruneOldLogFiles = function() {
	var logFolder =   Folder.myDocuments;
	if(logFolder.exists == true) {
		var files = logFolder.getFiles("Integration-X_LogFile*.txt");
		if(files != null) {
			if(files.length > LOGFILELIMIT) {
				var oldestDate = null;
				var oldestIndex = -1;
				for(var i = 0; i < files.length; i++) {
					if(oldestDate == null) {
						oldestDate = files[i].modified;
					}
					else {
						if(files[i].modified < oldestDate) {
							oldestDate = files[i].modified;
							oldestIndex = i;
						}
					}
				}
				if(oldestIndex != -1) {
                    ix.logF.writeln("Deleting old log file " + files[oldestIndex].fsName);
					files[oldestIndex].remove();
				}
			}
		}
	}
				
};

ix.logfile_open=function(myLogPath)
{
	ix.logF = new File(myLogPath);
	if(ix.logF.exists == true) {
		ix.archiveOldLog(myLogPath);
	}
	if (ix.logF != null)
	{
		ix.logF.open('w');
	}
}

ix.archiveOldLog = function(myLogPath) {
	var nameForOldLog = ix.getNameForOldLog();
    var res=false;
    try {
          var bu = new File(ix.ensurePathEndsInSlash(Folder.myDocuments.fsName)+nameForOldLog);
          bu.open('w');
          ix.logF.seek(0);
          var logBuffer = ix.logF.read();
          bu.write(logBuffer);
          bu.close();
          ix.logF.seek(0);
          ix.logF.writeln("Integration-X_LogFile_" + new Date().format("yyyyMMddhmmss") + ".txt");
          ix.logF.writeln ("js version: "+ix.version);       
          // res=ix.logF.rename(nameForOldLog) ;  
    }catch (e) {
        //$.writeln(e);
    }
    if (res==true) {
	    ix.logF = new File(myLogPath);
    } else {
        //$.writeln ("ix.archiveOldLog rename failed "+res+" "+ix.logF.error);
    }
};

ix.getNameForOldLog = function() {
	var ret = "";
	ix.logF.open('r');
	var firstLine = ix.logF.readln();
	if(firstLine.indexOf("Integration-X_LogFile") == 0) {
		ret = firstLine;
	}
	else {
		ret = "Integration-X_LogFile_old.txt";
	}
	return ret;
}

ix.logfile_close= function()
{
	if (ix.logF != null)
	{
		ix.logF.close();
	}
	ix.logF=null;
}
//-----------------

ix.flushTextFrame = function (theFrame)
{
         if (theFrame instanceof TextFrame == true) {
            try{
                if (theFrame.parentStory.characters.length>0)  
                    theFrame.parentStory.contents="";
            }
            catch (e) {
                ix.wr("ix.flushTextFrame "+" "+theFrame+" "+e);
            }
        }
}

// ix.colorAdd(app.activeDocument, "My RGB Color", ColorModel.PROCESS, ColorSpace.RGB, [0, 100, 0]);  
  
ix.colorAdd = function (myDocument, myColorName, myColorModel, myColorSpace, myColorValue) {  
      var myColor;
      var myName;
      try{  
        myColor = myDocument.colors.item(myColorName);  
        myName = myColor.name;  
      }  
      catch (myError){  
        myColor = myDocument.colors.add();  
        myColor.properties = {name:myColorName, model:myColorModel, space:myColorSpace ,colorValue:myColorValue};  
      }  
      return myColor;
}  


ix.getExtensionVersionFromManifest = function (extRoot) {
     var rtn = "?";
    var manFileName = extRoot+"/CSXS/Manifest.xml";
    var manifestXml = ix.readFileIntoXML(manFileName,"Manifest");
    if (manifestXml instanceof XML) {
   	 	ix.wr("getExtensionVersionFromManifest "+manifestXml.@ExtensionBundleVersion);   // jshint ignore:line
   	 	rtn = manifestXml.@ExtensionBundleVersion.toString();   // jshint ignore:line
    } else {
   	     ix.wr("getExtensionVersionFromManifest xml not read "+manifestXml);
    }
    
    return rtn;
};


ix.isItemOnMaster = function(item) {
	var rtn = false;
	try{
			if (item.parentPage.parent.constructor.name=="MasterSpread")  {rtn = true;}
	}
	catch (e) { rtn=false;}
	return rtn;
}

ix.itemIsOnAnotherMasterPage = function (myDoc,item) {

   if (ix.isItemOnMaster(item)==false) return false; // item not on a master page

    var spreads = myDoc.spreads;

    if (spreads.length <=0 ) return false;
    try {
        
        if (myDoc.spreads[0].appliedMaster==null) {
                return true;
        } else {
                var appliedMasterName = myDoc.spreads[0].appliedMaster.name;
                if (appliedMasterName != item.parentPage.parent.name) return true;
        }
        
    } catch (e) {
        ix.wr("itemIsOnAnotherMasterPage exception "+e);
        //$.bp (true);
    }

    return false;
}


ix.itemIsOnMyMasterPage = function (myPage, item) {

   ix.wr ("ix.itemIsOnMyMasterPage  "+myPage +"  "+item);
   if (item==null) return false;
   if (ix.isItemOnMaster(item)==false) return false; // item not on my master page

    
    try {
        
        if (myPage.appliedMaster==null) {
                return false;
        } else {
                var appliedMasterName = myPage.appliedMaster.name;
                if (appliedMasterName == item.parentPage.parent.name) return true;
        }
        
    } catch (e) {
        ix.wr("itemIsOnAnotherMasterPage exception "+e);
        //$.bp (true);
    }

    return false;
}


ix.closeThisPlanPointDoc = function (parentIdString) {
    ix.wr("closeThisPlanPointDoc "+parentIdString);
    return (ix.closeThisDoc(parentIdString));  // n.b, goes to diffcall back above
}

ix.closeThisDoc = function (parentIdString) {
    ix.wr("closeThisDoc "+parentIdString);
    try {
      var myDoc = app.activeDocument ;
    } catch (e) {
          ix.wr("closeThisDoc no doc exception "+e);
        return "";
    }

    try {
        myDoc.close(SaveOptions.NO);
     } catch (e) {
         ix.wr("closeThisDoc save exception "+e);
        return "";
    }
    return parentIdString;
}


ix.removeDeadAdsAtOpen = function (myLayoutObj, xmlImageList, pageIndex) {
   var item = null;
   var tmpstr= "";
    
   ix.wr("ix.removeDeadAdsAtOpen for "+myLayoutObj+" "+myLayoutObj.name+" "+pageIndex);
   ix.wr( xmlImageList.toXMLString() );
  
    /*if (myDoc instanceof Document == false) {
         ix.wrLog(" removeDeadAdsAtOpen - not a document ");
         return;
    }*/

   /* var parent = ix.getLabel(myDoc,"parent");
    if (parent==-1 || parent == "" ) {
         ix.wrLog(" removeDeadAdsAtOpen not a PlanPoint/AdPoint document. ");
         return;
    } */

    for (var y=0; y<myLayoutObj.pageItems.length; y++) {
        item = myLayoutObj.pageItems[y].getElements()[0];
        
        //ix.wr("    removeDeadAdsAtOpen found "+ item);
           
        if (ix.isItemOnMaster(item)==true) continue;  // skip MP items

        if ( item instanceof Rectangle == true  ||  item instanceof TextFrame == true) {  
             tmpstr = ix.readTheXMLAttributesAsXMLString (item,"image");
             try {
                     var xmlObj = new XML(tmpstr);
              } catch (e) {
                     ix.wr (" ix.removeDeadAdsAtOpen XML exception. "+e);
                     ix.wr (tmpstr);
                     ix.removeAnObject(item);
                     ix.wr(" item removed");
                     continue;
              }
          
              try {
                    var bean = xmlObj.@bean; 
                     // ix.wr(" ix.removeDeadAdsAtOpen read this bean as "+bean);
                     if (bean=="" || bean == undefined || bean ==null  ) {
                          // ix.wr("    ignore cause empty bean " + bean);
                         continue;
                     }
  
                    if (ix.isThisBeanInImageList (xmlImageList, bean)==false) {
                         if ( pageIndex>0 ) {
                             var pt = item.resolve(AnchorPoint.TOP_LEFT_ANCHOR,CoordinateSpaces.SPREAD_COORDINATES);
             //ix.wr (' !!! !!! resolved =  '+ parseFloat(pt[0])+'   '+pt[1]);
                             if (parseFloat(pt[0])<0) {
                                   ix.wr("    Remove found item from left page on right, skipping over. bean="+bean+" id="+item.id);
                                 continue;
                             }
                         }
                         ix.wr("    remove not found in xml image list bean="+bean+" id="+item.id);
                         item.locked=false;   
                         if (doDeleteCheck)  ix.removeDeleteCheckFromOneImage(item);
                         ix.removeAnObject(item);
                          continue;
                    } else {
                         ix.wr( "     Found bean in list "+bean);
                    }
                 } catch (e) {
                       ix.wr(" ix.removeDeadAdsAtOpen exception on bean or remove "+e);
                 }
             }
         }
 }
 
 ix.removeAnObject = function (frameObj) {
 
     if (frameObj==null || frameObj.isValid == false) {
         ix.wr(" ix. ix.removeAnObject invalid object "+ ix.removeAFrame+" "+frameObj);
         return;
     }
 
     try {
         frameObj.remove();
     } catch (e) {
         ix.wr(" ix. ix.removeAnObject exception "+e);
     }
 }
 
 ix.isThisBeanInImageList = function (imList, beanValue) {

    if (imList==undefined || imList.length()==0 ) return false;
 
    for (var i=0;i<imList.length();i++) {
        
//ix.wr("     ix.isThisBeanInImageList "+beanValue+" ?= "+imList[i].@bean.toString() );
        
        if ( beanValue == imList[i].@bean.toString() ) {
            return true;
        }
    }
    return false;
 }
 
 
 
function ReplaceWithTextFrame(in_frame) {
	
    var frame;
  do
  {
       if (in_frame instanceof TextFrame)
       {
         frame = in_frame;
         break;
       }
       
       var id = in_frame.id;
       var parent = in_frame.parent;
       frame = parent.pageItems.itemByID(id).getElements()[0];
       if (! (frame instanceof TextFrame))
       {
         if (frame.graphics.length > 0)
         {
           var err;
           try
           {
             while (frame.graphics.length > 0)
             {
               frame.graphics.item(0).remove();
             }
           }
           catch (err)
           {
           }     
         }
       }
              
       frame.contentType = ContentType.TEXT_TYPE;
       frame = parent.pageItems.itemByID(id).getElements()[0];
  }
  while (false);
  
  return (frame);
}
 
 // rtns exportPreset or null
ix.loadPDFPreset=function (pdfJobOptionsPath) {
          var preset=null;
          var optionName ="";
          do {
                  var jobOptionsFile = new File (pdfJobOptionsPath);
                  if (jobOptionsFile.exists==false) {
                      ix.wr ("ix.loadPDFPreset joboptions file not found "+pdfJobOptionsPath);
                      break;
                  }
                  optionName = jobOptionsFile.name.toString().replace(".joboptions","");
                  
                  try{
                           preset = app.pdfExportPresets.item (optionName); //.duplicate();   
                   } catch (e){
                           preset = null;
                  }
              
                  if (preset != undefined && preset.isValid == true) break; // okay we found it
                  // otherwise try to import it
                  try {
                     app.importFile (ExportPresetFormat.pdfExportPresetsFormat, jobOptionsFile);  
                  } catch (e) {
                      ix.wr(" ix.loadPDFPreset import exception "+e);
                  }
                  preset = app.pdfExportPresets.item(optionName);
                  if (preset == undefined && preset.isValid == false) preset=null;
          } while (false);
     
     if (preset instanceof PDFExportPreset) {
         ix.wr ("PDFExportPreset set to "+preset.name);
    }
     return preset
}


function forwardSlasher(tmpstr) {
	 var regex = /\\/g;
	 tmpstr =tmpstr.replace(regex,'/');
	 
	 //ix.wr("forwardSlasher "+tmpstr);
	 
	 return tmpstr;
}


function findSomePageXmlData (myDoc ) {
    var tmpstr = "";
    for (var y=0; y<myDoc.pages.length; y++) {
         tmpstr = ix.readTheXMLAttributesAsXMLString (myDoc.pages[y],"page");
         if (tmpstr !="") return tmpstr;
    }
    return tmpstr;
}

ix.attachDeleteChecks = function (myDoc) {
    for ( var x = 0; x<myDoc.pageItems.length; x++ ) {
        try {
               var pageItem =  myDoc.pageItems[x].getElements()[0];
                if (pageItem instanceof Rectangle == true || pageItem instanceof Oval == true && pageItem instanceof Polygon == true) { 
                    var beanID = ix.getLabel (pageItem, "bean");
                    if ( beanID == -1 || beanID == ""  || beanID ==undefined ) { continue; }

                    ix.wr(" attachDeleteChecks to beanID: "+   beanID     );   
                    ix.attachDeleteCheckToOneImage(pageItem);
               }
        } catch (e) {
                  ix.wr(" attachDeleteChecks exception "+e);
        }
    }
}


ix.attachDeleteCheckToOneImage = function (imageFrame) {
       try {
               if (imageFrame.graphics.length > 0) {
                    var image = imageFrame.graphics[0];
                    var theFile = new File(image.itemLink.filePath);
                    if (theFile.exists==true) {
                        var theLink = image.itemLink.addEventListener (Event.BEFORE_DELETE, confirmThis); 
                        ix.setLabel(imageFrame,"theListenerId",theLink.id);
                    }
                    ix.wr(" attachDeleteCheckToOneImage  "+image.itemLink.filePath);
              }
       } catch (e) {
           ix.wr(" attachDeleteCheckToOneImage  exception "+e);
       }
}


ix.removeDeleteCheckFromOneImage = function (imageFrame) {
       try {
               if (imageFrame.graphics.length > 0) {
                    var image = imageFrame.graphics[0];
                    //var theFile = new File(image.itemLink.filePath);
                    //if (theFile.exists==true) {
                         var theLinkid = ix.getLabel(imageFrame,"theListenerId");
          ix.wr("       theLinkid          "+theLinkid);
                         var theLink = app.eventListeners.itemByID(theLinkid);
          ix.wr("       theLink         "+theLink);
                         if (theLink.isValid==true) {
          ix.wr ("          remove link ");
                             theLink.remove();
                         }
                        //image.itemLink.removeEventListener (Event.BEFORE_DELETE, confirmThis); 
                   // }
                   ix.wr(" removeDeleteCheckFromOneImage  "+image.itemLink.filePath);
              }
       } catch (e) {
           ix.wr(" removeDeleteCheckFromOneImage  exception "+e);
       }
}

function confirmThis (evt) {
     ix.wr('confirmThis '+evt.constructor.name+" "+evt.target);
     if (app.documents.length == 0){return;}
  
    //if (ix.confirm("Are you certain you want to remove this?", "Integration-X")==false) {
    //        evt.preventDefault();  
    //}
}


ix.storyToTextFrame = function (st) {
	var textFrameObj=null;
	
	if (st==null || st ==undefined) return null;
	try {
				// this will not work if overset
				//textFrameObj = st.texts.item(0).parentTextFrames[0];
				// this will work if overset
				if (st.texts.item(0).parent.textContainers[0].constructor.name=="TextPath")
					textFrameObj = st.texts.item(0).parent.textContainers[0].parent;
				else
					textFrameObj = st.texts.item(0).parent.textContainers[0];
				return textFrameObj;			
    }
	catch (e)
	{
		ix.wr("ix.storyToTextFrame exception "+e);
		ix.wr (st.contents.substr(0,20));
	}

	return textFrameObj; 
}


ix.storyToPage = function (st) {
        var someObj=null;
        var myPage=null;
        var level=0;
        var rawPath="";
        if (st==null || st ==undefined) return null;

        someObj = st.texts.item(0).parent.textContainers[0];
         if (someObj.constructor.name!="TextFrame") {
             ix.wr("storyToPage error: TF not found - "+someObj.constructor.name +" not TextFrame. ");
         } else {
             myPage = someObj.parentPage;  // cs 5 obj model change
            
            if (Object.isValid (myPage)==false){
                  ix.wr("storyToPage() - Page null");
                return null;
             }
        }
    return myPage;
}

// if any relinks just rtn true
ix.doGraphicsNeedRelink = function (sg,ixPathToImage) {
   // var sg = myDoc.allGraphics;
    ix.wr("     ix.doGraphicsNeedRelink "+sg.length+" "+sg);
    for (var x=0; x<sg.length ; x++ ) {
        if (sg[x].itemLink==null) continue;
        
   ix.wr("     ix.doGraphicsNeedRelink status "+sg[x].itemLink.status);   
       ix.wr ("ixPathToImage "+ixPathToImage);
       ix.wr ("link path "+sg[x].itemLink.filePath);
   
        if (sg[x].itemLink.status == LinkStatus.LINK_MISSING || 
        sg[x].itemLink.status == LinkStatus.LINK_INACCESSIBLE ||
        sg[x].itemLink.status ==LinkStatus.LINK_OUT_OF_DATE ||
        sg[x].itemLink.status ==LinkStatus.LINK_MISSING) {
            return true;
        }

       try {
            var f1 = new File(ixPathToImage);
            var f2 = new File(sg[x].itemLink.filePath);

            if (f1.fsName != f2.fsName) {
                  ix.wr("     ix.doGraphicsNeedRelink file path 1 "+f1.fsName);
                  ix.wr("     ix.doGraphicsNeedRelink file path 2 "+f2.fsName);
                  return true;
            }
        } catch (e) {
              ix.wr("     ix.doGraphicsNeedRelink file path compare exception: "+e);
        }
    
    }
    return false;
}

//  image = graphics.firstItem()
//  pushed ( imageid id: & linkPath: new file loc from xml )  into temp arry - then idleDoOneRelink when done

ix.idleDoOneRelink = function (relinkObj) {
        ix.wr("ix.idleDoOneRelink .relink() start "+relinkObj.id+" "+relinkObj.linkPath);
       //if (new File(relinkObj.linkPath).exists == false) {
		//	ix.wr("ix.idleDoOneRelink invalid path "+e);
		//	return;   
      // }
       try {
          var im = app.activeDocument.pageItems.itemByID(relinkObj.id);
       } catch (e) {
           ix.wr("ix.idleDoOneRelink exception "+e);
           return;
       }

        if (im == null || im==undefined) {
			ix.wr("ix.idleDoOneRelink did not find image by id ");
			return;
		}

        if (im.parentPage == null || im.parentPage == undefined) {
			ix.wr("ix.idleDoOneRelink no parent page");
			return;
		}
    
        try {
			im.itemLink.relink(new File(relinkObj.linkPath));
		} catch (e) {
		    ix.wr("ix.idleDoOneRelink .relink() exception "+e);
		   return;
		}
 
        ix.wr("ix.idleDoOneRelink .relink() okay to "+relinkObj.linkPath);
        return;
}


ix.idleDoOnePlace = function (placeObj) {
        ix.wr("ix.idleDoOnePlace start "+placeObj.frameId+" "+placeObj.linkPath+" "+placeObj.docId);
      
         
      
       var myDoc = app.documents.itemByID(placeObj.docId);
       
        if (myDoc instanceof Document == false) {
            ix.wr("ix.idleDoOnePlace error - no doc "+placeObj.docId);
            return;
        }
       
       ix.importPostedImageToDoc  (myDoc,placeObj.frameId, placeObj.linkPath) ;
       
       ix.wr("ix.idleDoOnePlace finish "  );     
       
       return;
}

ix.idleDoOneReplace = function (pageObj) {
    
    try {
      var myDoc = pageObj.parent.parent;

      ix.searchAndReplaceOnThisPage ( myDoc,"<%W>", ix.weekday, pageObj );
      ix.searchAndReplaceOnThisPage ( myDoc,"<%M>", ix.month, pageObj );
      ix.searchAndReplaceOnThisPage ( myDoc,"<%D>", ix.day, pageObj );
      ix.searchAndReplaceOnThisPage ( myDoc,"<%Y>", ix.year, pageObj );
    } catch (e) {
        ix.wr("idleDoOneReplace exception "+e);
    }
}

ix.idleDoTellPPOpen = function (listOfPages) {
     ix.tell_JS ( "tellPPopen$"+listOfPages+"$" );
}

ix.idleDoTellADOpen = function( dataStr) {
    var aTmp=dataStr.split(delim);
    if (aTmp.length==2) {
        ix.tell_JS ( "tellADopen$"+aTmp[0]+"$"+aTmp[1] );   // 'tellADopen'$parentId$name
    }
}

//#targetengine "session"   // need session for debug !
//   -- idle events handler
//var ix={};

//  idlesImport.push( {frameId:theFrame.graphics[0].id,linkPath:rootFolder+imagePath,docId:myDoc.id} );
// ix.importPostedImage = function (frameID, imagePath) 

ix.handleTheIdle = function () {

    /* if (ix.idleDoc != null) {
          ix.wr(ix.idleDoc.name);
          ix.idleDoc=null;
    } */
    
    while (idlesDocs.length>0)  {  
         var myDoc = idlesDocs.pop(); 
         if ( myDoc != null) {    
            var docType = ix.tryToRenderDocument (myDoc) ;
            if (docType != "") {
                   ix.setLabel (myDoc, "docType", docType);
            }       
            ix.runIdleSubProcesses();
        } 
    }
    
} 

ix.runIdleSubProcesses = function () {

    while (idlesRelink.length>0)  {  ix.idleDoOneRelink( idlesRelink.pop() ); }
    
    while (idlesImport.length>0)  {  ix.idleDoOnePlace( idlesImport.pop() ); }
    
    while (idlesReturnOpenedPageList.length>0) { ix.idleDoTellPPOpen ( idlesReturnOpenedPageList.pop() ); }
    
    while (idlesReturnOpenedAdList.length>0) { ix.idleDoTellADOpen ( idlesReturnOpenedAdList.pop() ); }
    
    while (idlesReplaces.length>0) { ix.idleDoOneReplace (idlesReplaces.pop()); }
    
}

ix.eventsRenderADocLater = function (myDoc) {
   idlesDocs.push(myDoc);
}

ix.removeIdleTask = function() {
    ix.wr("ix.removeIdleTask");
	if (ix.idleTask != null) {
            ix.idleTask.remove();
            ix.idleTask = null;
     }
	
};

ix.addIdleTask = function() {
	ix.wr("ix.addIdleTask");
	try {
		ix.idleTask = app.idleTasks.add({name:"IXIdleTask", sleep:300});
		ix.idleTask.addEventListener("onIdle", ix.handleTheIdle);
		ix.wr ("ix.addIdleTask id " + ix.idleTask.id.toString());
	}
	catch(e) {
		ix.wr ("exception in ix.addIdleTask " + e.message);
	}
};


// ------------------  menus ------------------------------


function ixLoadMenus()
{
		var ixmenu=false;
		var myIXMainMenu=null;

		var myIXSaveAndExportMenu=null;
		var myIXSaveAndExportMenuEventListener=null;
		var myIXSaveAndExportMenuAction=null;

		var myIXSaveAndExportCustomMenu=null;
		var myIXSaveAndExportCustomMenuEventListener=null;
		var myIXSaveAndExportCustomMenuAction=null;

		var myIXSaveAsTemplateMenu=null;
		var myIXSaveAsTemplateMenuEventListener=null;
		var myIXSaveAsTemplateMenuAction=null;

		var myIXSaveOnlyMenu=null;
		var myIXSaveOnlyMenuEventListener=null;
		var myIXSaveOnlyMenuAction=null;


		var IXMAINMENUSTR = "AdPoint";
		var IXSAVEANDEXPORTMENUSTR = "Save and Export PDF";
		var IXSAVEANDEXPORTCUSTOMMENUSTR = "Save and Custom Export PDF";
		var IXSAVEASTEMPLATEMENUSTR = "Save As Template";
		var IXSAVEONLYMENUSTR = "Save only";



		//If the submenu "Script Menu Action" does not already exist, create it.
		//You might have to force InDesign to redraw the menu (by switching
		//out of the application and back again) to make the menu item appear.

		// AdPoint
		try{
			myIXMainMenu = app.menus.item("$ID/Main").submenus.item(IXMAINMENUSTR);
			myIXMainMenu.title;
		}
		catch (e){
			myIXMainMenu = app.menus.item("$ID/Main").submenus.add(IXMAINMENUSTR);
			ixmenu=true;
		}
		//  
		if ( ixCheckForMenuItem (myIXMainMenu,IXSAVEANDEXPORTMENUSTR) == false)
		{
			myIXSaveAndExportMenuAction = app.scriptMenuActions.add(IXSAVEANDEXPORTMENUSTR);
			myIXSaveAndExportMenuEventListener = myIXSaveAndExportMenuAction.eventListeners.add("onInvoke", ixMenuSaveAndExport, false);
			myIXSaveAndExportMenu = myIXMainMenu.menuItems.add(myIXSaveAndExportMenuAction);
		}
    
		if ( ixCheckForMenuItem (myIXMainMenu,IXSAVEANDEXPORTCUSTOMMENUSTR) == false)
		{
			myIXSaveAndExportCustomMenuAction = app.scriptMenuActions.add(IXSAVEANDEXPORTCUSTOMMENUSTR);
			myIXSaveAndExportCustomMenuEventListener = myIXSaveAndExportCustomMenuAction.eventListeners.add("onInvoke", ixMenuSaveAndExportCustom, false);
			myIXSaveAndExportCustomMenu = myIXMainMenu.menuItems.add(myIXSaveAndExportCustomMenuAction);
		}
    
		if ( ixCheckForMenuItem (myIXMainMenu,IXSAVEASTEMPLATEMENUSTR) == false)
		{
			myIXSaveAsTemplateMenuAction = app.scriptMenuActions.add(IXSAVEASTEMPLATEMENUSTR);
			myIXSaveAsTemplateMenuEventListener = myIXSaveAsTemplateMenuAction.eventListeners.add("onInvoke", ixMenuSaveAsTemplate, false);
			myIXSaveAsTemplateMenu = myIXMainMenu.menuItems.add(myIXSaveAsTemplateMenuAction);
		}
		if ( ixCheckForMenuItem (myIXMainMenu,IXSAVEONLYMENUSTR) == false)
		{
			myIXSaveOnlyMenuAction = app.scriptMenuActions.add(IXSAVEONLYMENUSTR);
			myIXSaveOnlyMenuEventListener = myIXSaveOnlyMenuAction.eventListeners.add("onInvoke",ixMenuSaveOnly, false);
			myIXSaveOnlyMenu = myIXMainMenu.menuItems.add(myIXSaveOnlyMenuAction);
		}

}

function ixCheckForMenuItem (myMenu, myString)
{
	var myResult = false;
	try{
		var myMenuItem = myMenu.menuItems.item(myString);
		myMenuItem.name;
		myResult = true;
	} catch(e) {
	    ix.wr("cfgCheckForMenuItem:"+e);
	}
	
	return myResult;
}


function ixMenuSaveAndExport() {
    ix.tell_JS ("SaveAndExport$ ");   
}

function ixMenuSaveAndExportCustom() {
     ix.tell_JS ("SaveAndExportCustom$ ");  
}

function ixMenuSaveOnly() {
    ix.tell_JS ("SaveOnly$ ");  
}

function ixMenuSaveAsTemplate() {
    ix.tell_JS ("SaveAsTemplate$ ");  
}


// saved idle event handler obj


// ix.addIdleTask ();


//------------- end logging----------

// begin unit tests
//ix.handleExports('SaveAndExportCustom','1461672241758_1','InDesign CC 2015','save');
//ix.init();

 //ix.init('/Library/Application Support/Adobe/CEP/extensions/com.integrationx.clientdebug');
 //ix.tryToRenderDocument (app.activeDocument);
//$.writeln(" moo ");

//ix.searchAndReplaceOnThisPage (app.activeDocument, "<%W>", "weekday" ,app.activeDocument.pages.item(0));

//  ix.exportToPlanPoint  ("SaveAndExport", "09999", "unit text","export");   // SaveAndExport
 
// ix.postImportImage (430, "/Users/peterjbaumgartner/adpoint/layoutdata/Page_1033/3055/103x375.pdf");
//ix.tryToRenderDocument (app.activeDocument );

//var d = ix.loadPDFPreset("/Users/peterjbaumgartner/adpoint/nativeappconfig/indesign.joboptions");
//$.writeln(d);
// var myDoc = app.activeDocument;
// ix.exportToPlanPoint();
//var fr = ix.createFrame( app.activeDocument.pages.item(0), {x:"10.647368421052633", y:"209.90526315789475"},831.0 ,194.0);
//$.writeln(fr.id);

//var xmlData = ix.readFileIntoXML(null,"find xml");
// ix.setCoordSchemeToPage (myDoc,0);
 // ix.renderDoc(myDoc,xmlData,0);
 //ix.restoreCoordScheme(myDoc);
 
  //  ix.saveTheXMLAttributes (myDoc,xmlData);
    
  // ix.readTheXMLAttributesAsXMLString  (myDoc, "resource" );

//$.writeln('done');